﻿param(
    [string]$path,
    [string]$filter
)
$xlFixedFormat = “Microsoft.Office.Interop.Excel.xlFixedFormatType” -as [type]
$objExcel = New-Object -ComObject excel.application
$objExcel.visible = $false
Get-ChildItem -LiteralPath $path -Filter $filter | ForEach-Object {
    $workbook = $objExcel.workbooks.open($_.FullName, 3)
    $pdf_filename = "$($_.DirectoryName)\$($_.BaseName).pdf"
    $workbook.Saved = $true
    $workbook.ExportAsFixedFormat($xlFixedFormat::xlTypePDF, [ref] $pdf_filename)
    $objExcel.Workbooks.close()
}
$objExcel.Quit()
