﻿param(
    [string]$documents_path,
    [string]$filter
)
$ppt_app = New-Object -ComObject Powerpoint.Application
$ppt_app.visible = $false
# This filter will find .ppt as well as .pptx documents if the filter is *.ppt?
Get-ChildItem -LiteralPath $documents_path -Filter $filter | ForEach-Object {
    $pp = $ppt_app.Presentations.Open($_.FullName)
    $pdf_filename = "$($_.DirectoryName)\$($_.BaseName).pdf"
    $pp.SaveAs([ref] $pdf_filename, [ref] 32)
    $pp.Close()
}
$ppt_app.Quit()