﻿param(
    [string]$path,
    [string]$filter
)
$word_app = New-Object -ComObject Word.Application
$word_app.visible = $false
# This filter will find .doc as well as .docx documents if the filter is *.doc?
Get-ChildItem -LiteralPath $path -Filter $filter | ForEach-Object {
    $document = $word_app.Documents.Open($_.FullName)
    $pdf_filename = "$($_.DirectoryName)\$($_.BaseName).pdf"
    $document.SaveAs([ref] $pdf_filename, [ref] 17)
    $document.Close()
}
$word_app.Quit()