﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private htmlstring As String
End Sub
Public Sub Initialize
	htmlstring = ""
End Sub
Public Sub set_htmlpage(strtext As String,mode As String,theme As String) As String
	Private sb As StringBuilder
	sb.Initialize
	sb = html_header(sb,theme,mode)
	sb = html_body(sb,strtext,mode,theme)
	sb = html_footer(sb)
	htmlstring = sb.ToString
	Return htmlstring
End Sub
Private Sub html_header(sb As StringBuilder,theme As String,mode As String) As StringBuilder
	sb.Append("<html>")
	sb.Append("<head>")
	sb.Append("<meta name='viewport' content='width=device-width, initial-scale=1'>")
	sb.Append("<meta charset='UTF-8'>")
	sb = add_stylesheet(sb,"codemirror.css")
	sb = add_stylesheet(sb,"eclipse.css")
	sb = add_stylesheet(sb,"show-hint.css")
	sb = add_stylesheet(sb,"foldgutter.css")
	sb = add_stylesheet(sb,"dialog_codemirror.css")
	If theme <> "" And theme <> "default" Then sb = add_stylesheet(sb,theme & ".css")
	sb = add_javascript(sb,"codemirror.js")
	sb = add_javascript(sb,"b4x.js")
	sb = add_javascript(sb,"javascript.js")
	sb = add_javascript(sb,"htmlmixed.js")
	sb = add_javascript(sb,"css.js")
	sb = add_javascript(sb,"clike.js")	'needed for php
	sb = add_javascript(sb,"php.js")
	sb = add_javascript(sb,"vb.js")
	sb = add_javascript(sb,"sql.js")
	sb = add_javascript(sb,"xml.js")
	sb = add_javascript(sb,"show-hint.js")
	sb = add_javascript(sb,"anyword-hint.js")
	sb = add_javascript(sb,"css-hint.js")
	sb = add_javascript(sb,"html-hint.js")
	sb = add_javascript(sb,"javascript-hint.js")
	sb = add_javascript(sb,"sql-hint.js")
	sb = add_javascript(sb,"xml-hint.js")
	sb = add_javascript(sb,"foldcode.js")
	sb = add_javascript(sb,"foldgutter.js")
	sb = add_javascript(sb,"comment-fold.js")
	sb = add_javascript(sb,"indent-fold.js")
	sb = add_javascript(sb,"brace-fold.js")
	sb = add_javascript(sb,"active-line.js")
	sb = add_javascript(sb,"jump-to-line.js")
	sb = add_javascript(sb,"search.js")
	sb = add_javascript(sb,"searchcursor.js")
	sb = add_javascript(sb,"dialog.js")
	Return sb
End Sub
Private Sub html_body(sb As StringBuilder, strtext As String,mode As String,theme As String) As StringBuilder
	Dim strmode As String = mode
	If mode = "vb" Then strmode = "text/x-vb"
	If mode = "php" Then strmode = "application/x-httpd-php"
	If mode = "sql" Then strmode = "text/x-sql"
	If mode = "java" Then strmode = "text/x-java"
	sb.Append("</head><body style='background-color:#DDDAFF;'>")
	sb.Append("<textarea id='editor'>").Append(strtext).Append("</textarea>").Append(CRLF)
	Dim strcm As String = $"
<script> var editor = CodeMirror.fromTextArea(document.getElementById('editor'), { 
mode:'${strmode}',	
theme:'${theme}',
styleActiveLine:true,
lineNumbers:true,
lineWrapping:true,
dragDrop:true,
indentUnit:2,
indentWithTabs:true,
tabMode:'shift',
enterMode:'flat',
foldGutter: { rangeFinder: new CodeMirror.fold.combine(CodeMirror.fold.indent, CodeMirror.fold.comment, CodeMirror.fold.brace) },
gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter']
 });
editor.on('keydown', function(editor,event){
if (!(event.ctrlKey) && (event.keyCode >= 65 && event.keyCode <= 90) || (event.keyCode >= 97 && event.keyCode <= 122) || (event.keyCode >= 46 && event.keyCode <= 57) ) {
CodeMirror.commands.autocomplete(editor); }
});
editor.setSize('null','100%');
editor.setOption('extraKeys', {
  "Ctrl-Space": "autocomplete",
  "Ctrl-Y": "foldAll",
  "Ctrl-I": "unfoldAll",
  "Ctrl-Q": function(editor){ editor.foldCode(editor.getCursor()); }
});
editor.foldCode(CodeMirror.Pos(0, 0));
</script>
	"$
	sb.Append(strcm)
'	Log(sb)
	Return sb
End Sub
Private Sub html_footer(sb As StringBuilder) As StringBuilder
	sb.Append("</body></html>")
	Return sb
End Sub
private Sub add_stylesheet(sb As StringBuilder, fname As String) As StringBuilder
	Dim css As String = File.ReadString(File.DirAssets,fname)
	sb.Append("<style type='text/css'>").Append(css).Append("</style>").Append(CRLF)
	Return sb
End Sub
private Sub add_javascript(sb As StringBuilder, fname As String) As StringBuilder
	Dim js As String = File.ReadString(File.DirAssets,fname)
	sb.Append("<script>").Append(js).Append("</script>").Append(CRLF)
	Return sb
End Sub

